Index: mediaportal/Core/Player/FFDShow/FFDShowEngine.cs
===================================================================
--- mediaportal/Core/Player/FFDShow/FFDShowEngine.cs	(revision 0)
+++ mediaportal/Core/Player/FFDShow/FFDShowEngine.cs	(revision 0)
@@ -0,0 +1,454 @@
+#region Copyright (C) 2005-2010 Team MediaPortal
+
+// Copyright (C) 2005-2010 Team MediaPortal
+// http://www.team-mediaportal.com
+// 
+// MediaPortal is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 2 of the License, or
+// (at your option) any later version.
+// 
+// MediaPortal is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+// GNU General Public License for more details.
+// 
+// You should have received a copy of the GNU General Public License
+// along with MediaPortal. If not, see <http://www.gnu.org/licenses/>.
+
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Drawing;
+using System.Runtime.InteropServices;
+using DirectShowLib;
+using MediaPortal.GUI.Library;
+using DShowNET.Helper;
+using MediaPortal.Profile;
+using FFDShow;
+using FFDShow.Interfaces;
+using MediaPortal.Player.PostProcessing;
+
+namespace MediaPortal.Player.Subtitles
+{
+  public class FFDShowEngine : SubSettings, ISubEngine, IPostProcessingEngine
+  {
+    private FFDShowAPI ffdshowAPI;
+    private string[] subFiles = null;
+    private bool hasPostProcessing = false;
+
+    protected override void LoadAdvancedSettings(Settings xmlreader)
+    {
+      //TODO : custom settings for FFDShow (normally hold in presets, not sure if this is useful)
+      /*int subPicsBufferAhead = xmlreader.GetValueAsInt("subtitles", "subPicsBufferAhead", 3);
+      bool pow2textures = xmlreader.GetValueAsBool("subtitles", "pow2tex", false);
+      string textureSize = xmlreader.GetValueAsString("subtitles", "textureSize", "Medium");
+      bool disableAnimation = xmlreader.GetValueAsBool("subtitles", "disableAnimation", true);
+
+      int w, h;
+      int screenW = GUIGraphicsContext.Width;
+      int screenH = GUIGraphicsContext.Height;
+      bool res1080 = (screenW == 1920 && screenH == 1080);
+      bool res720 = (screenW >= 1280 && screenW <= 1368 && screenH >= 720 && screenH <= 768);
+
+      if (textureSize.Equals("Desktop"))
+      {
+        w = screenW;
+        h = screenH;
+      }
+      else if (textureSize.Equals("Low"))
+      {
+        if (res1080)
+        {
+          w = 854;
+          h = 480;
+        }
+        else if (res720)
+        {
+          w = 512;
+          h = 288;
+        }
+        else
+        {
+          w = (int)(Math.Round(screenW / 3.0));
+          h = (int)(Math.Round(screenH / 3.0));
+        }
+      }
+      else //if (textureSize.Equals("Medium"))
+      {
+        if (res1080)
+        {
+          w = 1280;
+          h = 720;
+        }
+        else if (res720)
+        {
+          w = 854;
+          h = 480;
+        }
+        else
+        {
+          w = (int)(Math.Round(screenW * 2.0 / 3));
+          h = (int)(Math.Round(screenH * 2.0 / 3));
+        }
+      }
+      Log.Debug("FFDShowEngine: using texture size of {0}x{1}", w, h);
+      Size size = new Size(w, h);
+      MpcSubtitles.SetAdvancedOptions(subPicsBufferAhead, size, pow2textures, disableAnimation);*/
+    }
+
+    #region ISubEngine Members
+
+    public bool LoadSubtitles(IGraphBuilder graphBuilder, string filename)
+    {
+      LoadSettings();
+
+      //remove DirectVobSub
+      DirectVobSubUtil.RemoveFromGraph(graphBuilder);
+      {
+        //remove InternalScriptRenderer as it takes subtitle pin
+        IBaseFilter isr = null;
+        DirectShowUtil.FindFilterByClassID(graphBuilder, ClassId.InternalScriptRenderer, out isr);
+        if (isr != null)
+        {
+          graphBuilder.RemoveFilter(isr);
+          DirectShowUtil.ReleaseComObject(isr);
+        }
+      }
+      // Window size
+      //Size size = new Size(GUIGraphicsContext.Width, GUIGraphicsContext.Height);
+      /*List<FFDShowAPI.FFDShowInstance> ffdshowInstance = FFDShowAPI.getFFDShowInstances();
+      FFDShowAPI.FFDShowAPI api = new FFDShowAPI();*/
+
+
+
+      IBaseFilter baseFilter = null;
+        DirectShowUtil.FindFilterByClassID(graphBuilder, FFDShowAPI.FFDShowVideoGuid, out baseFilter);
+      if (baseFilter == null)
+        DirectShowUtil.FindFilterByClassID(graphBuilder, FFDShowAPI.FFDShowVideoDXVAGuid, out baseFilter);
+      if (baseFilter == null)
+        DirectShowUtil.FindFilterByClassID(graphBuilder, FFDShowAPI.FFDShowVideoRawGuid, out baseFilter);
+      if (baseFilter == null)
+        return false;
+
+      ffdshowAPI = new FFDShowAPI((object)baseFilter);
+      //ffdshowAPI.checkFFDShowActive();
+
+      IffdshowDec ffdshowDec = baseFilter as IffdshowDec;
+      if (ffdshowDec == null)
+      {
+        //SubEngine.engine = new SubEngine.DummyEngine2();
+        //Log.Info("FFDshow Engine: ffdshow no present -> disable FFDShowEngine");
+        Log.Error("FFdshow interfaces not found. Try to update FFDShow");
+      }
+      else
+        Log.Info("FFdshow interfaces found");
+
+      return true;
+      /*return MpcSubtitles.LoadSubtitles(
+        DirectShowUtil.GetUnmanagedDevice(GUIGraphicsContext.DX9Device),
+        size, filename, graphBuilder, subPaths);*/
+    }
+
+    public void FreeSubtitles()
+    {
+      //MpcSubtitles.FreeSubtitles();
+    }
+
+    public void SaveToDisk()
+    {
+      //MpcSubtitles.SaveToDisk();
+    }
+
+    public bool IsModified()
+    {
+      return false;
+      //return MpcSubtitles.IsModified();
+    }
+
+    public AutoSaveTypeEnum AutoSaveType
+    {
+      get { return this.autoSaveType; }
+    }
+
+    public void Render(Rectangle subsRect, Rectangle frameRect)
+    {
+      /*Rectangle r = posRelativeToFrame ? frameRect : subsRect;
+      int posY = adjustPosY * r.Height / GUIGraphicsContext.Height;
+      MpcSubtitles.Render(r.X, r.Y + posY, r.Width, r.Height);*/
+    }
+
+    public int GetCount()
+    {
+      int cnt = ffdshowAPI.SubtitleStreams.Count;
+      Log.Debug("FFDShowEngine : " + cnt + " subtitle streams");
+      return cnt;
+    }
+
+    public string GetLanguage(int i)
+    {
+      FFDShowAPI.Streams subtitleStreams = ffdshowAPI.SubtitleStreams;
+      int index = 0;
+      foreach (KeyValuePair<int, FFDShowAPI.Stream> streamPair in subtitleStreams)
+      {
+        if (index == i) return streamPair.Value.languageName;
+        index++;
+      }
+      return "";
+    }
+
+    public string GetSubtitleName(int i)
+    {
+      FFDShowAPI.Streams subtitleStreams = ffdshowAPI.SubtitleStreams;
+      int index = 0;
+      foreach (KeyValuePair<int, FFDShowAPI.Stream> streamPair in subtitleStreams)
+      {
+        if (index == i) return streamPair.Value.name;
+        index++;
+      }
+      return "";
+    }
+
+    public int Current
+    {
+      get
+      {
+        int index = 0;
+        FFDShowAPI.Streams subtitleStreams = ffdshowAPI.SubtitleStreams;
+        foreach (KeyValuePair<int, FFDShowAPI.Stream> subtitleStream in subtitleStreams)
+        {
+          if (subtitleStream.Value.enabled)
+            return index;
+          index++;
+        }
+        return -1; //Pour que la selection par defaut des subs soit OK avec NO SUBTITLE
+      }
+      set
+      {
+        int index = 0;
+        FFDShowAPI.Streams subtitleStreams = ffdshowAPI.SubtitleStreams;
+        foreach (KeyValuePair<int, FFDShowAPI.Stream> subtitleStream in subtitleStreams)
+        {
+          if (index == value)
+          {
+            ffdshowAPI.SubtitleStream = subtitleStream.Key;
+            return;
+          }
+          index++;
+        }
+      }
+    }
+
+    public bool Enable
+    {
+      get { return ffdshowAPI.SubtitlesEnabled; }
+      set { ffdshowAPI.SubtitlesEnabled = value; }
+    }
+
+    public int DelayInterval //?? What for ??
+    {
+      get { return delayInterval; }
+    }
+
+    public int Delay
+    {
+      get { return ffdshowAPI.SubtitlesDelay; }
+      set { ffdshowAPI.SubtitlesDelay = value; }
+    }
+
+    public void DelayPlus()
+    {
+      Delay = Delay + delayInterval;
+    }
+
+    public void DelayMinus()
+    {
+      Delay = Delay - delayInterval;
+    }
+
+    public void SetTime(long nsSampleTime) //?? What for ??
+    {
+      //MpcSubtitles.SetTime(nsSampleTime);
+    }
+
+    #region Subtitle files
+    public string[] GetSubtitleFiles()
+    {
+      return ffdshowAPI.SubtitleFiles;
+
+    }
+    public string CurrentSubtitleFile
+    {
+      get
+      {
+        return ffdshowAPI.CurrentSubtitleFile;
+      }
+      set
+      {
+        ffdshowAPI.CurrentSubtitleFile = value;
+      }
+    }
+    #endregion
+
+    #endregion
+
+    #region IPostProcessing Members
+    public bool LoadPostProcessing(IGraphBuilder graphBuilder)
+    {
+      IBaseFilter baseFilter = null;
+      // No Postprocessing for FFDShow DXVA decoder
+      DirectShowUtil.FindFilterByClassID(graphBuilder, FFDShowAPI.FFDShowVideoGuid, out baseFilter);
+      if (baseFilter == null)
+        DirectShowUtil.FindFilterByClassID(graphBuilder, FFDShowAPI.FFDShowVideoRawGuid, out baseFilter);
+      if (baseFilter == null) return false;
+      ffdshowAPI = new FFDShowAPI((object)baseFilter);
+      hasPostProcessing = true;
+      return true;
+    }
+
+    public bool HasPostProcessing
+    {
+      get { return hasPostProcessing; }
+    }
+    public bool EnableResize
+    {
+      get
+      {
+        return ffdshowAPI.DoResize;
+      }
+      set
+      {
+        ffdshowAPI.DoResize = value;
+      }
+    }
+    public bool EnablePostProcess
+    {
+      get
+      {
+        return ffdshowAPI.DoPostProcessing;
+      }
+      set
+      {
+        ffdshowAPI.DoPostProcessing = value;
+      }
+    }
+
+    public void SwitchToNextSubtitleSub()
+    {
+      if (ffdshowAPI.DoShowSubtitles)
+      {
+        // Cycle through subtitle streams and files
+        string currentSubFile = CurrentSubtitleFile;
+        subFiles = GetSubtitleFiles();
+        int subStreams = GetCount();
+        int nextSubStream = Current + 1;
+        int subIndex = -1;
+        if ((currentSubFile != null && !currentSubFile.Equals("")) || nextSubStream >= subStreams)
+        {
+          if (currentSubFile != null && !currentSubFile.Equals(""))
+          {
+            for (int i = 0; i < subFiles.Length; i++)
+            {
+              if (currentSubFile.Equals(subFiles[i]))
+              {
+                subIndex = i;
+                break;
+              }
+            }
+          }
+          subIndex++;
+          if (subIndex < subFiles.Length) // Next subtitle file
+          {
+            CurrentSubtitleFile = subFiles[subIndex];
+            return;
+          }
+          // Disable subtitles if last sub file reached
+          ffdshowAPI.DoShowSubtitles = false;
+          return;
+        }
+        // End of sub streams => first subtitle file or disable subtitles
+        if (nextSubStream >= subStreams)
+        {
+          if (subFiles.Length > 0)
+          {
+            CurrentSubtitleFile = subFiles[0];
+            return;
+          }
+          ffdshowAPI.DoShowSubtitles = false;
+          return;
+        }
+        Current = nextSubStream;
+      }
+      else // Subtitles disabled : first sub stream if any or first sub file
+      {
+        ffdshowAPI.DoShowSubtitles = true;
+        FFDShowAPI.Streams subStreams = ffdshowAPI.SubtitleStreams;
+        if (subStreams.Count > 0)
+        {
+          foreach (KeyValuePair<int, FFDShowAPI.Stream> stream in subStreams)
+          {
+            ffdshowAPI.SubtitleStream = stream.Key;
+            return;
+          }
+        }
+
+        subFiles = GetSubtitleFiles();
+        if (subFiles.Length > 0) CurrentSubtitleFile = subFiles[0];
+      }
+    }
+
+
+    public bool EnableDeinterlace
+    {
+      get
+      {
+        return ffdshowAPI.DoDeinterlace;
+      }
+      set
+      {
+        ffdshowAPI.DoDeinterlace = value;
+      }
+    }
+
+    public bool EnableCrop
+    {
+      get
+      {
+        return ffdshowAPI.DoCropZoom;
+      }
+      set
+      {
+        ffdshowAPI.DoCropZoom = value;
+      }
+    }
+
+    public int CropVertical
+    {
+      get
+      {
+        return ffdshowAPI.CropVertical;
+      }
+      set
+      {
+        ffdshowAPI.DoCropZoom = true;
+        ffdshowAPI.CropVertical = value;
+      }
+    }
+    public int CropHorizontal
+    {
+      get
+      {
+        return ffdshowAPI.CropHorizontal;
+      }
+      set
+      {
+        ffdshowAPI.DoCropZoom = true;
+        ffdshowAPI.CropHorizontal = value;
+      }
+    }
+
+    #endregion
+  }
+}
Index: mediaportal/Core/Player/FFDShow/FFDShowReceiver.cs
===================================================================
--- mediaportal/Core/Player/FFDShow/FFDShowReceiver.cs	(revision 0)
+++ mediaportal/Core/Player/FFDShow/FFDShowReceiver.cs	(revision 0)
@@ -0,0 +1,132 @@
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Runtime.InteropServices;
+using System.Diagnostics;
+using System.Threading;
+using System.Windows.Forms;
+
+
+
+namespace FFDShow
+{
+    /// <summary>
+    /// This class is instantiated and used by FFDShowAPI to receive the answers from FFDShow
+    /// It must derivate from System.Windows.Forms.Form because FFDShow communication API is based on
+    /// windows messages. This class is not used directly by user.
+    /// </summary>
+    public class FFDShowReceiver : System.Windows.Forms.Form
+    {
+
+        /// <summary>
+        /// The CopyData Constant for SendMessage
+        /// </summary>
+        public const Int32 WM_COPYDATA = 0x004A;
+
+       
+        [StructLayout(LayoutKind.Sequential)]
+        internal struct COPYDATASTRUCT
+        {
+            internal UIntPtr dwData;
+            internal uint cbData;
+            internal IntPtr lpData;
+        }
+
+        /// <summary>
+        /// Received string
+        /// </summary>
+        private String receivedString = null;
+        /// <summary>
+        /// Received type : identifier of the requested parameter
+        /// </summary>
+        private Int32 receivedType = 0;
+
+        /// <summary>
+        /// Thread instance of FFDShowAPI waiting for the response
+        /// </summary>
+        private Thread parentThread;
+
+        /// <summary>
+        /// Gets or sets the string received from FFDShow
+        /// </summary>
+        public String ReceivedString
+        {
+            get
+            {
+                return receivedString;
+            }
+            set
+            {
+                receivedString = value;
+            }
+        }
+
+        /// <summary>
+        /// Gets or sets the identifier of the value to retrieve
+        /// </summary>
+        public Int32 ReceivedType
+        {
+            get
+            {
+                return receivedType;
+            }
+            set
+            {
+                receivedType = value;
+            }
+        }
+
+
+        #region Constructors
+        /// <summary>
+        /// FFDShowReceiver constructor
+        /// </summary>
+        /// <param name="parentThread">FFDShowAPI thread to be interrupted once the response is received</param>
+        public FFDShowReceiver(Thread parentThread)
+        {
+            this.parentThread = parentThread;
+        }
+        #endregion Constructors
+
+        /// <summary>
+        /// Main method that receives window messages
+        /// We handle only for WM_COPYDATA messages
+        /// </summary>
+        /// <param name="m"></param>
+        protected override void WndProc(ref Message m)
+        {
+            if (m.Msg == WM_COPYDATA)
+            {
+                try
+                {
+                    COPYDATASTRUCT cd = new COPYDATASTRUCT();
+                    cd = (COPYDATASTRUCT)Marshal.PtrToStructure(m.LParam, typeof(COPYDATASTRUCT));
+
+#if UNICODE
+                    string returnedData = Marshal.PtrToStringUni(cd.lpData);
+#else
+                    string returnedData = Marshal.PtrToStringAnsi(cd.lpData);
+#endif
+                    receivedString = returnedData;
+                    receivedType = (int)cd.dwData.ToUInt32();
+
+                    /*if (receivedString != null)
+                        Debug.WriteLine("Receiver got " + receivedType + " " + receivedString);
+                    else
+                        Debug.WriteLine("Receiver got " + receivedType + " NULL");
+                    Debug.Flush();*/
+
+                    if (parentThread != null && parentThread.ThreadState == System.Threading.ThreadState.WaitSleepJoin)
+                        parentThread.Interrupt();
+                    //resetEvent.Set();
+                }
+                catch (Exception)
+                {
+                    /*Debug.Write(e.StackTrace.ToString());
+                    Debug.Flush();*/
+                }
+            }
+            base.WndProc(ref m);
+        }
+    }
+}
Index: mediaportal/Core/Player/FFDShow/Interfaces/DirectShow.cs
===================================================================
--- mediaportal/Core/Player/FFDShow/Interfaces/DirectShow.cs	(revision 0)
+++ mediaportal/Core/Player/FFDShow/Interfaces/DirectShow.cs	(revision 0)
@@ -0,0 +1,77 @@
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Runtime.InteropServices;
+using System.Security;
+
+namespace FFDShow.Interfaces
+{
+  [ComImport, SuppressUnmanagedCodeSecurity,
+  Guid("c1960960-17f5-11d1-abe1-00a0c905f375"),
+  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
+  public interface IAMStreamSelect
+  {
+    [PreserveSig]
+    int Count([Out] out int pcStreams);
+
+    [PreserveSig]
+    int Info(
+      [In] int lIndex,
+      [Out] out AMMediaType ppmt,
+      [Out] out AMStreamSelectInfoFlags pdwFlags,
+      [Out] out int plcid,
+      [Out] out int pdwGroup,
+      [Out, MarshalAs(UnmanagedType.LPWStr)] out string ppszName,
+      [Out, MarshalAs(UnmanagedType.IUnknown)] out object ppObject,
+      [Out, MarshalAs(UnmanagedType.IUnknown)] out object ppUnk
+      );
+
+    [PreserveSig]
+    int Enable(
+      [In] int lIndex,
+      [In] AMStreamSelectEnableFlags dwFlags
+      );
+  }
+
+  /// <summary>
+  /// From _AMSTREAMSELECTINFOFLAGS
+  /// </summary>
+  [Flags]
+  public enum AMStreamSelectInfoFlags
+  {
+    Disabled = 0x0,
+    Enabled = 0x01,
+    Exclusive = 0x02
+  }
+
+  /// <summary>
+  /// From _AMSTREAMSELECTENABLEFLAGS
+  /// </summary>
+  [Flags]
+  public enum AMStreamSelectEnableFlags
+  {
+    DisableAll = 0x0,
+    Enable = 0x01,
+    EnableAll = 0x02
+  }
+
+  /// <summary>
+  /// From AM_MEDIA_TYPE - When you are done with an instance of this class,
+  /// it should be released with FreeAMMediaType() to avoid leaking
+  /// </summary>
+  [StructLayout(LayoutKind.Sequential)]
+  public class AMMediaType
+  {
+    public Guid majorType;
+    public Guid subType;
+    [MarshalAs(UnmanagedType.Bool)]
+    public bool fixedSizeSamples;
+    [MarshalAs(UnmanagedType.Bool)]
+    public bool temporalCompression;
+    public int sampleSize;
+    public Guid formatType;
+    public IntPtr unkPtr; // IUnknown Pointer
+    public int formatSize;
+    public IntPtr formatPtr; // Pointer to a buff determined by formatType
+  }
+}
Index: mediaportal/Core/Player/FFDShow/Interfaces/IffDecoder.cs
===================================================================
--- mediaportal/Core/Player/FFDShow/Interfaces/IffDecoder.cs	(revision 0)
+++ mediaportal/Core/Player/FFDShow/Interfaces/IffDecoder.cs	(revision 0)
@@ -0,0 +1,139 @@
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Runtime.InteropServices;
+
+namespace FFDShow.Interfaces
+{
+    [Guid("00F99063-70D5-4bcc-9D88-3801F3E3881B"),
+    InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
+    public interface IffDecoder
+    {
+        int compat_getParam(uint paramID, out int value);
+        int compat_getParam2(uint paramID);
+        int compat_putParam(uint paramID, int value);
+        int compat_getNumPresets(out uint value);
+        int compat_getPresetName(uint i, [In, MarshalAs(UnmanagedType.AnsiBStr)] string buf, uint len);
+        int compat_getActivePresetName([In, MarshalAs(UnmanagedType.AnsiBStr)] string buf, uint len);
+        int compat_setActivePreset([In, MarshalAs(UnmanagedType.AnsiBStr)] string name, int create);
+        int compat_getAVIdimensions(out uint x, out uint y);
+        int compat_getAVIfps(out uint fps1000);
+        int compat_saveActivePreset([In, MarshalAs(UnmanagedType.AnsiBStr)] string name);
+        int compat_saveActivePresetToFile([In, MarshalAs(UnmanagedType.AnsiBStr)] string flnm);
+        int compat_loadActivePresetFromFile([In, MarshalAs(UnmanagedType.AnsiBStr)] string flnm);
+        int compat_removePreset([In, MarshalAs(UnmanagedType.AnsiBStr)] string name);
+        int compat_notifyParamsChanged();
+        int compat_getAVcodecVersion([Out, MarshalAs(UnmanagedType.AnsiBStr)] string buf, uint len);
+        int compat_getPPmode(out uint ppmode);
+        int compat_getRealCrop(out uint left, out uint top, out uint right, out uint bottom);
+        int compat_getMinOrder2();
+        int compat_getMaxOrder2();
+        int compat_saveGlobalSettings();
+        int compat_loadGlobalSettings();
+        int compat_saveDialogSettings();
+        int compat_loadDialogSettings();
+        //int compat_getPresets (Tpresets *presets2);
+        //int compat_setPresets (const Tpresets *presets2);
+        int compat_getPresets(IntPtr presets2);
+        int compat_setPresets (IntPtr presets2);
+        int compat_savePresets();
+        //int compat_getPresetPtr (Tpreset**preset);
+        //int compat_setPresetPtr (Tpreset *preset);
+        int compat_getPresetPtr (IntPtr preset);
+        int compat_setPresetPtr (IntPtr preset);
+        int compat_renameActivePreset([In, MarshalAs(UnmanagedType.AnsiBStr)] string newName);
+        int compat_setOnChangeMsg(IntPtr wnd, uint msg);
+        int compat_setOnFrameMsg(IntPtr wnd, uint msg);
+        int compat_isDefaultPreset([In, MarshalAs(UnmanagedType.AnsiBStr)] string presetName);
+        int compat_showCfgDlg(IntPtr owner);
+        int compat_getXvidVersion([Out, MarshalAs(UnmanagedType.AnsiBStr)] string buf, uint len);
+        //int compat_getMovieSource (const TvideoCodecDec* *moviePtr);
+        int compat_getMovieSource (IntPtr moviePtr);
+        int compat_getOutputDimensions(out uint x, out uint y);
+        int compat_getCpuUsage2();
+        int compat_getOutputFourcc([Out, MarshalAs(UnmanagedType.AnsiBStr)] string buf, uint len);
+        int compat_getInputBitrate2();
+        int compat_getHistogram(uint[] dst);
+        int compat_setFilterOrder(uint filterID, uint newOrder);
+        //int compat_buildHistogram (const TffPict *pict,int full);
+        int compat_buildHistogram (IntPtr pict,int full);
+        int compat_cpuSupportsMMX();
+        int compat_cpuSupportsMMXEXT();
+        int compat_cpuSupportsSSE();
+        int compat_cpuSupportsSSE2();
+        int compat_cpuSupports3DNOW();
+        int compat_cpuSupports3DNOWEXT();
+        int compat_getAVIfps1000_2();
+        int compat_getParamStr(uint paramID, [Out, MarshalAs(UnmanagedType.AnsiBStr)] string buf, uint buflen);
+        int compat_putParamStr(uint paramID, [In, MarshalAs(UnmanagedType.AnsiBStr)] string buf);
+        int compat_invParam(uint paramID);
+        int compat_getInstance(IntPtr hi);
+        int compat_saveKeysSettings();
+        int compat_loadKeysSettings();
+        int compat_seek(int seconds);
+        int compat_tell(out int seconds);
+        int compat_getDuration(out int seconds);
+        int compat_getKeyParamCount2();
+        int compat_getKeyParamDescr(uint i, [Out, MarshalAs(UnmanagedType.AnsiBStr)] string[] descr);
+        int compat_getKeyParamKey2(uint i);
+        int compat_setKeyParamKey(uint i, int key);
+        //int compat_getImgFilters (TimgFilters* *imgFiltersPtr);
+        int compat_getImgFilters (IntPtr imgFiltersPtr);
+        int compat_getQuant(out int[] quantPtr);
+        int compat_calcNewSize(uint inDx, uint inDy, out uint outDx, out uint outDy);
+        int compat_grabNow();
+        int compat_getOverlayControlCapability(int idff); //S_OK - can be set, S_FALSE - not supported
+        int compat_getParamName(uint i, [Out, MarshalAs(UnmanagedType.AnsiBStr)] string buf, uint len);
+        //int compat_getTranslator (Ttranslate* *trans);
+        int compat_getTranslator (IntPtr trans);
+        int compat_getIffDecoderVersion2();
+        int compat_lock(int lockId);
+        int compat_unlock(int lockId);
+        int compat_getInstance2();
+        //int compat_getGraph(out IFilterGraph graphPtr);
+        //int compat_getConfig (Tconfig* *configPtr);
+        int compat_getGraph(IntPtr graphPtr);
+        int compat_getConfig (IntPtr configPtr);
+        int compat_initDialog();
+        int compat_initPresets();
+        int compat_calcMeanQuant(out float quant);
+        int compat_initKeys();
+        //int compat_savePresetMem (void *buf,uint len); //if len=0, then buf should point to int variable which will be filled with required buffer length
+        //int compat_loadPresetMem (const void *buf,uint len);
+        //int compat_getGlobalSettings (TglobalSettingsDecVideo* *globalSettingsPtr);
+        int compat_createTempPreset([In, MarshalAs(UnmanagedType.AnsiBStr)] string presetName);
+        string compat_getParamStr2(uint paramID); //returns const pointer to string, NULL if fail
+        int compat_findAutoSubflnm2();
+        int compat_getCurrentFrameTime(out uint sec);
+        int compat_getFrameTime(uint framenum, out uint sec);
+        int compat_getCurTime2();
+        //int compat_getPostproc (Tlibmplayer* *postprocPtr);
+        int compat_stop();
+        int compat_run();
+        int compat_getState2();
+        int compat_resetFilter(uint filterID);
+        int compat_resetFilterEx(uint filterID, uint filterPageId);
+        int compat_getFilterTip(uint filterID, [Out, MarshalAs(UnmanagedType.AnsiBStr)] string buf, uint buflen);
+        int compat_getFilterTipEx(uint filterID, uint filterPageId, [Out, MarshalAs(UnmanagedType.AnsiBStr)] string buf, uint buflen);
+        int compat_filterHasReset(uint filterID);
+        int compat_filterHasResetEx(uint filterID, uint filterPageId);
+        int compat_shortOSDmessage([In, MarshalAs(UnmanagedType.AnsiBStr)] string msg, uint duration); //duration is in frames
+        int compat_shortOSDmessageAbsolute([In, MarshalAs(UnmanagedType.AnsiBStr)] string msg, uint duration, uint posX, uint posY); //duration is in frames
+        int compat_cleanShortOSDmessages();
+        //int compat_setImgFilters (TimgFilters *imgFiltersPtr);
+        int compat_registerSelectedMediaTypes();
+        int compat_getFrameTimes(out double start, out double stop);
+        int compat_getSubtitleTimes(out double start, out double stop);
+        int compat_resetSubtitleTimes();
+        int compat_setFrameTimes(double start, double stop);
+        int compat_cpuSupportsSSE41();
+        int compat_cpuSupportsSSE42();
+        int compat_cpuSupportsSSE4A();
+        int compat_cpuSupportsSSE5();
+        int compat_cpuSupportsSSE3();
+        int compat_cpuSupportsSSSE3();
+        int compat_getIffDecoder2Version();
+        int compat_getParamStrW(uint paramID, [Out, MarshalAs(UnmanagedType.BStr)] string buf, uint buflen);
+        int compat_putParamStrW(uint paramID, [In, MarshalAs(UnmanagedType.BStr)] string buf);
+    };
+}
